
%  Copyright (c) 2013
%      Oliver van Kaick <ovankaic@gmail.com>

function G = get_conn_comp(points, gr, cluster)

    % Init components
    G = {};
    % Init index for current component
    g = 1;
    % Init marks
    visited = zeros(size(points, 1), 1);
    % Process points
    for i = 1:length(cluster)
        % Get current point
        p = cluster(i);
        % If point was not visited, it means that it was not yet added to
        % a component
        if ~visited(p)
            % Initialize current component
            G{g} = [];
            % Do a flood fill starting from the current point
            queue = [p];
            visited(p) = 1;
            while ~isempty(queue)
                % Add point to the current component and remove it from
                % the queue
                pt = queue(1);
                queue = queue(2:end);
                G{g}(end+1) = pt;
                % Process its neighbors
                for j = 1:length(gr{pt})
                    % Get neighbor 'j'
                    cand = gr{pt}(j);
                    % Check if neighbor is also part of the cluster
                    if length(find(cluster == cand)) > 0
                        % Add it to the queue if it is not in the queue and
                        % not yet visited
                        if ~visited(cand)
                            queue(end+1) = cand;
                            visited(cand) = 1;
                        end
                    end
                end
            end
            % Increase number of connected components
            g = g + 1;
        end
    end
end
