
%  Copyright (c) 2013
%      Oliver van Kaick <ovankaic@gmail.com>

function dist = get_dist_to_boundary(points, clusters, gr)

    mp = clusters_to_clustering(clusters);

    dist = inf*ones(length(clusters), size(points, 1));
    for i = 1:length(clusters)
        % Find boundary points
        bp = [];
        for j = 1:length(clusters{i})
            if length(find(mp(gr{clusters{i}(j)}) ~= i)) > 0
                bp(end+1) = clusters{i}(j);
            end
        end
        disp(['    Segment ' num2str(i) ': ' num2str(length(bp)) ' boundary points']);
        drawnow('update');
        bp = bp(randperm(length(bp)));
        if length(bp) > 50
            bp = bp(1:50);
        end
        % Get distance from boundary points
        for j = 1:length(bp)
            [D, P] = point_shortest_path(points, gr, bp(j));
            % Trick to change Inf for the max value
            % There can be Inf if the points are disconnected
            sel = (D > 3.4028e+37);
            D(sel) = -Inf;
            mx = max(D);
            D(sel) = mx;
            % Assign distance
            dist(i, :) = min(dist(i, :), D');
        end
        dist(i, :) = map_func(dist(i, :), 0, 1);
    end
end
