
%  Copyright (c) 2013
%      Oliver van Kaick <ovankaic@gmail.com>

function [labeling, patches, gc_adjacency] = run_gc_small(points, normals, gr, clusters, point_adj, max_elen)%, seeds)
    
weight = 0.1; % Weight assigned to make data cost bigger/smaller than smoothness cost
len_pow = 1; % Power to weight the edge length term
ang_pow = 1; % Power to weight the edge angle term
norm_avg = 0; % Use average of neighbors as point normal

if 1
seg = clusters;
disp('Building graphcuts graph'); drawnow('update');
gc_adjacency = build_adjacency_small(points, normals, gr, len_pow, ang_pow, norm_avg, point_adj, max_elen);
disp('Building terms'); drawnow('update');
dist = get_dist_to_boundary(points, seg, gr);
[datacost, smoothness] = build_terms_small(points, gr, seg, dist);
end
disp('Running graph cut'); drawnow('update');
gch = GraphCut('open', weight*datacost, smoothness, gc_adjacency);
[gch graphcut_idx] = GraphCut('expand', gch);
gch = GraphCut('close', gch);
graphcut_idx = graphcut_idx';
graphcut_idx = double(graphcut_idx)+1;
graphcut_patches = clustering_to_clusters(graphcut_idx);
graphcut_patches = remove_empty_segments(graphcut_patches);
graphcut_idx = clusters_to_clustering(graphcut_patches);

labeling = graphcut_idx;
patches = graphcut_patches;
    
end
